<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>task 31.30 jquery</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container-fluid"
        style="background-image:url(./LuckyDiceImagesv2023Feb/cover.jpg) ;min-height: 100px;margin: auto; ">
    </div>
    <div class="container " style="margin-top: 20px;">
        <div class="row ">
            <div class="col-sm-5">
                <div class="row form-group">
                    <h4>Nhập thông tin của bạn </h4>
                </div>
                <div class="row  form-group">
                    <div class="col-sm-4"><label for="">User Name</label></div>
                    <div class="col-sm-8"> <input id="use-name" type="text" class="form-control"
                            placeholder="Nhập user name.. "></div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4"><label for="">First Name</label></div>
                    <div class="col-sm-8"> <input id="first-name" type="text" class="form-control"
                            placeholder=" Nhập first name.."></div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4"><label for="">Last Name</label></div>
                    <div class="col-sm-8"> <input id="last-name" type="text" class="form-control"
                            placeholder=" Nhập last name .."></div>
                </div>
            </div>
            <div class="col-sm-4  text-center ">
                <div class="row form-group ">
                    <div class="col-sm-12 ">
                        <button id="on-nem-click" class="btn btn-success">Ném # new-dice</button>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-12">
                        <img id="img-dice" class="img-thumbnail" src="./LuckyDiceImagesv2023Feb/1.png" alt="">
                    </div>
                </div>
                <div class="row ">
                    <div class="col-sm-12">
                        <p id="p-chuc-mung" style="display: none;">chúc mừng </p>
                    </div>
                </div>
            </div>
            <div class="col-sm-3  text-center">
                <div class="row">
                    <div class="col-sm-12">
                        <p>Voucher:</p>
                        <p id="id-voucher">Không có mã giảm giá</p>
                        <p id="ma-giam-gia">Không có mã giảm giá</p>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12">
                        <img id="img-phan-thuong" class="img-thumbnail" src="./LuckyDiceImagesv2023Feb/no-present.jpg"
                            alt="">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center">
            <div class="col form-group">
                <button id="btn-dice-history" class="btn btn-success">Dice history</button>
                <button id="btn-voucher-history" class="btn btn-primary">Voucher history</button>
                <button id="btn-precent-history" class="btn btn-primary">Precent history</button>
            </div>
        </div>
        <div class="row ">
            <div class="col form-group">
                <table id="table" class="table table-striped table-bordered table-hover">
                    <thead>
                        <tr>
                            <th>Lượt</th>
                            <th>dice</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict"
    // hàm sự kiện khi load toàn bộ thẻ body 
    $(document).ready(function () {
        "use strict"

        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        // Hằng số các cột 
        const gCot1 = 0;
        const gCot2 = 1;
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        $("#btn-dice-history").on("click", onDiceHistoryClick);
        $("#btn-voucher-history").on("click", onVoucherHistoryClick);
        $("#btn-precent-history").on("click", onPrecentHistoryClick);
        $("#on-nem-click").on("click", onNemClick);

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // khai báo hàm ném 
        function onNemClick() {
            console.log("đã ấn nút ném");
            // gồm 4 bước xử lý 
            // object decralation 
            var vObject = {
                userName: "",
                firstName: "",
                lastName: ""
            }
            // step 1 collect data 
            getCollectData(vObject);
            // step 2 validate data
            var vResult = getValidateData(vObject)
            // step 3 call sever api 
            if (vResult) {
                console.log("meet the connditions"); // đáp ứng các điều kiện 
                // create a request ( Tạo 1 request)
                // bước 3 gọi api
                var vXmlHttpDice = new XMLHttpRequest();
                getNewDiceApi(vXmlHttpDice, vObject);
                vXmlHttpDice.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                        //hãy REFACTORING ĐẨY MÃ NGUỒN XỬ LÝ RA FUNCTION KHÁC
                        console.log(vXmlHttpDice.responseText);
                        // parsing to object
                        var vResponse = JSON.parse(vXmlHttpDice.responseText);
                        // get result dice
                        var vDiceReady = vResponse.dice;  // mã súc sắc
                        var vVoucher = vResponse.voucher;  // voucher 
                        var vPrize = vResponse.prize;    // phần thưởng 
                        console.log("dice result:= " + vDiceReady);   // in mã súc sắc
                        // bước 4 hiển thị ảnh dice 
                        getHienThiAnhDice(vDiceReady, vVoucher, vPrize);
                    }
                }
            }
            // display data on the wed 

        }
        // khai báo hàm nút bấm dice history
        function onDiceHistoryClick() {
            console.log("đã ấn nút dice history");
        }
        // khai báo hàm nút bấm voucher history 
        function onVoucherHistoryClick() {
            console.log("đã ấn nút voucher history");
        }
        // khai báo hàm nút bấm precent history ( tiền sử )
        function onPrecentHistoryClick() {
            console.log("đã ấn nút precent history");
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // declaration function getCollectData
        function getCollectData(paramObject) {
            //  assign value to object 
            paramObject.userName = $("#use-name").val().trim();
            paramObject.firstName = $("#first-name").val().trim();
            paramObject.lastName = $("#last-name").val().trim();
        }
        // check the input of person information 
        function getValidateData(paramObject) {

            if (paramObject.userName == "") {
                alert("please enter user name");
                return false;
            }
            if (paramObject.firstName == "") {
                alert("please enter first name");
                return false;
            }
            if (paramObject.lastName == "") {
                alert("please enter last name");
                return false;
            }
            return true;
        }
        // bước 3 gọi api để lấy đẩy thông tin lên máy chủ 
        // nhận về đối tượng chưas thônng tin giải thưởng  
        function getNewDiceApi(pramXmlHttp, paramObject) {
            //base url
            const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
            const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
            // data to be sent by post method
            pramXmlHttp.open("POST", vBASE_URL + "/dice", true);
            pramXmlHttp.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
            pramXmlHttp.send(JSON.stringify(paramObject));  //chuyển Json object sang string
        }
        // bước 4 hiển thị hình ảnh và voucher khi nhận được đối tượng trả về 
        // bao gồm dice . phần thưởng . mã giảm giá
        function getHienThiAnhDice(paramDice, paramVoucher, paramPrize) {
            // làm trắng thẻ p
            var vElementP = document.getElementById("p-chuc-mung");
            vElementP.style.display = "block";
            // truy xuất phần tử cần hiển thị
            var vElementDice = document.getElementById("img-dice");
            if (paramDice == 1) {
                vElementDice.setAttribute("src", "./LuckyDiceImagesv2023Feb/1.png");
            }
            if (paramDice == 2) {
                vElementDice.setAttribute("src", "./LuckyDiceImagesv2023Feb/2.png");
            }
            if (paramDice == 3) {
                vElementDice.setAttribute("src", "./LuckyDiceImagesv2023Feb/3.png");
            }
            if (paramDice == 4) {
                vElementDice.setAttribute("src", "./LuckyDiceImagesv2023Feb/4.png");
            }
            if (paramDice == 5) {
                vElementDice.setAttribute("src", "./LuckyDiceImagesv2023Feb/5.png");
            }
            if (paramDice == 6) {
                vElementDice.setAttribute("src", "./LuckyDiceImagesv2023Feb/6.png");
            }
            // Hiển thị voucher nếu có 
            if (paramVoucher != null) {
                var vElementIdVoucher = document.getElementById("id-voucher");
                var vElementMaGiamGia = document.getElementById("ma-giam-gia");
                vElementIdVoucher.innerHTML = paramVoucher.id;
                vElementMaGiamGia.innerHTML = paramVoucher.phanTramGiamGia;
            }
            // không nhận được mã giảm giá 
            if (paramVoucher == null) {
                var vElementIdVoucher = document.getElementById("id-voucher");
                var vElementMaGiamGia = document.getElementById("ma-giam-gia");
                vElementIdVoucher.innerHTML = "Không có mã giảm giá ";
                vElementMaGiamGia.innerHTML = "Không có mã giảm giá  ";
            }
            // không nhận được mã giảm giá 
            if (paramPrize == null) {
                var vElementPrize = document.getElementById("img-phan-thuong");
                vElementPrize.setAttribute("src", "./LuckyDiceImagesv2023Feb/no-present.jpg");
            }
            // hiển thị ảnh phần thưởng nếu có
            if (paramPrize != null) {
                var vElementPrize = document.getElementById("img-phan-thuong");
                if (paramPrize == "Sổ") {
                    vElementPrize.setAttribute("src", "./LuckyDiceImagesv2023Feb/book.jpg");
                }
                if (paramPrize == "Xe máy") {
                    vElementPrize.setAttribute("src", "./LuckyDiceImagesv2023Feb/xe-may.jpg");
                }
                if (paramPrize == "Mũ") {
                    vElementPrize.setAttribute("src", "./LuckyDiceImagesv2023Feb/hat.jpg");
                }
                if (paramPrize == "Bút") {
                    vElementPrize.setAttribute("src", "./LuckyDiceImagesv2023Feb/but.png");
                }
                if (paramPrize == "Áo mưa") {
                    vElementPrize.setAttribute("src", "./LuckyDiceImagesv2023Feb/ao-mua.jpg");
                }
            }
        }
        // kết thúc hàm hiển thị 
        // hàm hiển thị dice history 
        function getHienThiTable(paramArr) {
            console.log("hien thi");
            var vElementTable = document.getElementById("table");
            var vTbody = vElementTable.getElementsByTagName("tbody")[0];
            var vHead = vElementTable.getElementsByTagName("thead")[0];
            // lamf trắng  body và head  
            //vHead.innerHTML = "";
            vTbody.innerHTML = "";
            // gán inerhtml
            // Chèn nhiều  dòng mới 
            for (var i = 0; paramArr.length > i; i++) {
                var vRow = vTbody.insertRow(-1);
                // thêm các cột 
                var vColLuot = vRow.insertCell(gCot1);
                var vColDice = vRow.insertCell(gCot2);
                // Thêm giá trị mới bằng iner html
                vColLuot.innerHTML = i;
                vColDice.innerHTML = paramArr[i];
            }
        }


    });

</script>

</html>